/* Generated: Wed Sep 06 2017 14:22:38 GMT-0600 (MDT) */

static void CCONV PhidgetMotorPositionController_errorHandler(PhidgetChannelHandle ch,
  Phidget_ErrorEventCode code);
static PhidgetReturnCode CCONV PhidgetMotorPositionController_bridgeInput(PhidgetChannelHandle phid,
  BridgePacket *bp);
static PhidgetReturnCode CCONV PhidgetMotorPositionController_setStatus(PhidgetChannelHandle phid,
  BridgePacket *bp);
static PhidgetReturnCode CCONV PhidgetMotorPositionController_getStatus(PhidgetChannelHandle phid,
  BridgePacket **bp);
static PhidgetReturnCode CCONV PhidgetMotorPositionController_initAfterOpen(PhidgetChannelHandle phid);
static PhidgetReturnCode CCONV PhidgetMotorPositionController_setDefaults(PhidgetChannelHandle phid);
static void CCONV PhidgetMotorPositionController_fireInitialEvents(PhidgetChannelHandle phid);

struct _PhidgetMotorPositionController {
	struct _PhidgetChannel phid;
	int64_t positionOffset;
	double acceleration;
	int acceleration_isSet;
	double minAcceleration;
	double maxAcceleration;
	double currentLimit;
	int currentLimit_isSet;
	double minCurrentLimit;
	double maxCurrentLimit;
	double currentRegulatorGain;
	double minCurrentRegulatorGain;
	double maxCurrentRegulatorGain;
	uint32_t dataInterval;
	int dataInterval_isSet;
	uint32_t minDataInterval;
	uint32_t maxDataInterval;
	uint32_t deadBand;
	int deadBand_isSet;
	double dutyCycle;
	int engaged;
	int engaged_isSet;
	Phidget_FanMode fanMode;
	Phidget_EncoderIOMode IOMode;
	double kd;
	int kd_isSet;
	double kp;
	int kp_isSet;
	int64_t position;
	int64_t minPosition;
	int64_t maxPosition;
	double rescaleFactor;
	double stallVelocity;
	int stallVelocity_isSet;
	double minStallVelocity;
	double maxStallVelocity;
	int64_t targetPosition;
	int targetPosition_isSet;
	double velocityLimit;
	int velocityLimit_isSet;
	double minVelocityLimit;
	double maxVelocityLimit;
	PhidgetMotorPositionController_OnDutyCycleUpdateCallback DutyCycleUpdate;
	void *DutyCycleUpdateCtx;
	PhidgetMotorPositionController_OnPositionChangeCallback PositionChange;
	void *PositionChangeCtx;
};

static PhidgetReturnCode CCONV
_setStatus(PhidgetChannelHandle phid, BridgePacket *bp) {
	PhidgetMotorPositionControllerHandle ch;
	int version;

	ch = (PhidgetMotorPositionControllerHandle)phid;

	version = getBridgePacketUInt32ByName(bp, "_class_version_");
	if (version != 0) {
		logerr("%P: bad version %d != 0", phid, version);
		return (EPHIDGET_BADVERSION);
	}

	ch->positionOffset = getBridgePacketInt64ByName(bp, "positionOffset");
	ch->acceleration = getBridgePacketDoubleByName(bp, "acceleration");
	ch->minAcceleration = getBridgePacketDoubleByName(bp, "minAcceleration");
	ch->maxAcceleration = getBridgePacketDoubleByName(bp, "maxAcceleration");
	ch->currentLimit = getBridgePacketDoubleByName(bp, "currentLimit");
	ch->minCurrentLimit = getBridgePacketDoubleByName(bp, "minCurrentLimit");
	ch->maxCurrentLimit = getBridgePacketDoubleByName(bp, "maxCurrentLimit");
	ch->currentRegulatorGain = getBridgePacketDoubleByName(bp, "currentRegulatorGain");
	ch->minCurrentRegulatorGain = getBridgePacketDoubleByName(bp, "minCurrentRegulatorGain");
	ch->maxCurrentRegulatorGain = getBridgePacketDoubleByName(bp, "maxCurrentRegulatorGain");
	ch->dataInterval = getBridgePacketUInt32ByName(bp, "dataInterval");
	ch->minDataInterval = getBridgePacketUInt32ByName(bp, "minDataInterval");
	ch->maxDataInterval = getBridgePacketUInt32ByName(bp, "maxDataInterval");
	ch->deadBand = getBridgePacketUInt32ByName(bp, "deadBand");
	ch->dutyCycle = getBridgePacketDoubleByName(bp, "dutyCycle");
	ch->engaged = getBridgePacketInt32ByName(bp, "engaged");
	ch->fanMode = getBridgePacketInt32ByName(bp, "fanMode");
	ch->IOMode = getBridgePacketInt32ByName(bp, "IOMode");
	ch->kd = getBridgePacketDoubleByName(bp, "kd");
	ch->kp = getBridgePacketDoubleByName(bp, "kp");
	ch->position = getBridgePacketInt64ByName(bp, "position");
	ch->minPosition = getBridgePacketInt64ByName(bp, "minPosition");
	ch->maxPosition = getBridgePacketInt64ByName(bp, "maxPosition");
	ch->rescaleFactor = getBridgePacketDoubleByName(bp, "rescaleFactor");
	ch->stallVelocity = getBridgePacketDoubleByName(bp, "stallVelocity");
	ch->minStallVelocity = getBridgePacketDoubleByName(bp, "minStallVelocity");
	ch->maxStallVelocity = getBridgePacketDoubleByName(bp, "maxStallVelocity");
	ch->targetPosition = getBridgePacketInt64ByName(bp, "targetPosition");
	ch->velocityLimit = getBridgePacketDoubleByName(bp, "velocityLimit");
	ch->minVelocityLimit = getBridgePacketDoubleByName(bp, "minVelocityLimit");
	ch->maxVelocityLimit = getBridgePacketDoubleByName(bp, "maxVelocityLimit");

	return (EPHIDGET_OK);
}

static PhidgetReturnCode CCONV
_getStatus(PhidgetChannelHandle phid, BridgePacket **bp) {
	PhidgetMotorPositionControllerHandle ch;

	ch = (PhidgetMotorPositionControllerHandle)phid;

	return (createBridgePacket(bp, 0, "_class_version_=%u"
	  ",positionOffset=%l"
	  ",acceleration=%g"
	  ",minAcceleration=%g"
	  ",maxAcceleration=%g"
	  ",currentLimit=%g"
	  ",minCurrentLimit=%g"
	  ",maxCurrentLimit=%g"
	  ",currentRegulatorGain=%g"
	  ",minCurrentRegulatorGain=%g"
	  ",maxCurrentRegulatorGain=%g"
	  ",dataInterval=%u"
	  ",minDataInterval=%u"
	  ",maxDataInterval=%u"
	  ",deadBand=%u"
	  ",dutyCycle=%g"
	  ",engaged=%d"
	  ",fanMode=%d"
	  ",IOMode=%d"
	  ",kd=%g"
	  ",kp=%g"
	  ",position=%l"
	  ",minPosition=%l"
	  ",maxPosition=%l"
	  ",rescaleFactor=%g"
	  ",stallVelocity=%g"
	  ",minStallVelocity=%g"
	  ",maxStallVelocity=%g"
	  ",targetPosition=%l"
	  ",velocityLimit=%g"
	  ",minVelocityLimit=%g"
	  ",maxVelocityLimit=%g"
	  ,0 /* class version */
	  ,ch->positionOffset
	  ,ch->acceleration
	  ,ch->minAcceleration
	  ,ch->maxAcceleration
	  ,ch->currentLimit
	  ,ch->minCurrentLimit
	  ,ch->maxCurrentLimit
	  ,ch->currentRegulatorGain
	  ,ch->minCurrentRegulatorGain
	  ,ch->maxCurrentRegulatorGain
	  ,ch->dataInterval
	  ,ch->minDataInterval
	  ,ch->maxDataInterval
	  ,ch->deadBand
	  ,ch->dutyCycle
	  ,ch->engaged
	  ,ch->fanMode
	  ,ch->IOMode
	  ,ch->kd
	  ,ch->kp
	  ,ch->position
	  ,ch->minPosition
	  ,ch->maxPosition
	  ,ch->rescaleFactor
	  ,ch->stallVelocity
	  ,ch->minStallVelocity
	  ,ch->maxStallVelocity
	  ,ch->targetPosition
	  ,ch->velocityLimit
	  ,ch->minVelocityLimit
	  ,ch->maxVelocityLimit
	));
}

static PhidgetReturnCode CCONV
_bridgeInput(PhidgetChannelHandle phid, BridgePacket *bp) {
	PhidgetMotorPositionControllerHandle ch;
	PhidgetReturnCode res;

	ch = (PhidgetMotorPositionControllerHandle)phid;
	res = EPHIDGET_OK;

	switch (bp->vpkt) {
	case BP_SETACCELERATION:
		TESTRANGE(getBridgePacketDouble(bp, 0), ch->minAcceleration, ch->maxAcceleration);
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->acceleration = getBridgePacketDouble(bp, 0);
		ch->acceleration_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "Acceleration");
		break;
	case BP_SETCURRENTLIMIT:
		TESTRANGE(getBridgePacketDouble(bp, 0), ch->minCurrentLimit, ch->maxCurrentLimit);
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->currentLimit = getBridgePacketDouble(bp, 0);
		ch->currentLimit_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "CurrentLimit");
		break;
	case BP_SETCURRENTREGULATORGAIN:
		TESTRANGE(getBridgePacketDouble(bp, 0), ch->minCurrentRegulatorGain,
		  ch->maxCurrentRegulatorGain);
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->currentRegulatorGain = getBridgePacketDouble(bp, 0);
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "CurrentRegulatorGain");
		break;
	case BP_SETDATAINTERVAL:
		TESTRANGE(getBridgePacketUInt32(bp, 0), ch->minDataInterval, ch->maxDataInterval);
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->dataInterval = getBridgePacketUInt32(bp, 0);
		ch->dataInterval_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "DataInterval");
		break;
	case BP_SETDEADBAND:
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->deadBand = getBridgePacketUInt32(bp, 0);
		ch->deadBand_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "DeadBand");
		break;
	case BP_SETENGAGED:
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->engaged = getBridgePacketInt32(bp, 0);
		ch->engaged_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "Engaged");
		break;
	case BP_SETFANMODE:
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->fanMode = getBridgePacketInt32(bp, 0);
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "FanMode");
		break;
	case BP_SETIOMODE:
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->IOMode = getBridgePacketInt32(bp, 0);
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "IOMode");
		break;
	case BP_SETKD:
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->kd = getBridgePacketDouble(bp, 0);
		ch->kd_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "Kd");
		break;
	case BP_SETKP:
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->kp = getBridgePacketDouble(bp, 0);
		ch->kp_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "Kp");
		break;
	case BP_SETSTALLVELOCITY:
		TESTRANGE(getBridgePacketDouble(bp, 0), ch->minStallVelocity, ch->maxStallVelocity);
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->stallVelocity = getBridgePacketDouble(bp, 0);
		ch->stallVelocity_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "StallVelocity");
		break;
	case BP_SETTARGETPOSITION:
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->targetPosition = getBridgePacketInt64(bp, 0);
		ch->targetPosition_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "TargetPosition");
		break;
	case BP_SETDUTYCYCLE:
		TESTRANGE(getBridgePacketDouble(bp, 0), ch->minVelocityLimit, ch->maxVelocityLimit);
		res = DEVBRIDGEINPUT(phid, bp);
		if (res != EPHIDGET_OK) {
			logerr("%P: DEVBRIDGEINPUT() failed: %d", phid, res);
			break;
		}
		ch->velocityLimit = getBridgePacketDouble(bp, 0);
		ch->velocityLimit_isSet = PTRUE;
		if (bridgePacketIsFromNet(bp))
			FIRE_PROPERTYCHANGE(ch, "VelocityLimit");
		break;
	case BP_DUTYCYCLECHANGE:
		ch->dutyCycle = getBridgePacketDouble(bp, 0);
		FIRECH(ch, DutyCycleUpdate, ch->dutyCycle);
		break;
	default:
		logerr("%P: unsupported bridge packet:0x%x", phid, bp->vpkt);
		res = EPHIDGET_UNSUPPORTED;
	}

	return (res);
}

static PhidgetReturnCode CCONV
_initAfterOpen(PhidgetChannelHandle phid) {
	PhidgetMotorPositionControllerHandle ch;
	PhidgetReturnCode ret;

	TESTPTRL(phid);
	ch = (PhidgetMotorPositionControllerHandle)phid;

	ret = EPHIDGET_OK;


	switch (phid->UCD->uid) {
	case PHIDCHUID_DCC1000_MOTORPOSITIONCONTROLLER_200:
		ch->dataInterval = 100;
		ch->dataInterval_isSet = PTRUE;
		ch->minDataInterval = 20;
		ch->maxDataInterval = 60000;
		ch->currentLimit = 2;
		ch->currentLimit_isSet = PTRUE;
		ch->maxCurrentLimit = 25;
		ch->minCurrentLimit = 2;
		ch->currentRegulatorGain = 10;
		ch->dutyCycle = PUNK_DBL;
		ch->engaged = 0;
		ch->engaged_isSet = PTRUE;
		ch->maxCurrentRegulatorGain = 100;
		ch->minCurrentRegulatorGain = 1;
		ch->velocityLimit = 20000;
		ch->velocityLimit_isSet = PTRUE;
		ch->minVelocityLimit = 0;
		ch->maxVelocityLimit = 250000;
		ch->maxAcceleration = 10000000;
		ch->minAcceleration = 0.1;
		ch->acceleration = 10000;
		ch->acceleration_isSet = PTRUE;
		ch->targetPosition = 0;
		ch->targetPosition_isSet = PTRUE;
		ch->position = PUNK_INT64;
		ch->maxPosition = 1000000000000000;
		ch->minPosition = -1000000000000000;
		ch->rescaleFactor = 1;
		ch->fanMode = FAN_MODE_AUTO;
		ch->deadBand = 0;
		ch->deadBand_isSet = PTRUE;
		ch->kp = 10;
		ch->kp_isSet = PTRUE;
		ch->kd = 3000;
		ch->kd_isSet = PTRUE;
		ch->IOMode = ENCODER_IO_MODE_PUSH_PULL;
		break;
	case PHIDCHUID_DCC1001_MOTORPOSITIONCONTROLLER_100:
		ch->dataInterval = 100;
		ch->dataInterval_isSet = PFALSE;
		ch->minDataInterval = 20;
		ch->maxDataInterval = 60000;
		ch->currentLimit = 1;
		ch->currentLimit_isSet = PFALSE;
		ch->maxCurrentLimit = 3.5;
		ch->minCurrentLimit = 0;
		ch->dutyCycle = PUNK_DBL;
		ch->engaged = 0;
		ch->engaged_isSet = PFALSE;
		ch->velocityLimit = 20000;
		ch->velocityLimit_isSet = PFALSE;
		ch->minVelocityLimit = 0;
		ch->maxVelocityLimit = 250000;
		ch->maxAcceleration = 10000000;
		ch->minAcceleration = 0.1;
		ch->acceleration = 10000;
		ch->acceleration_isSet = PFALSE;
		ch->targetPosition = 0;
		ch->targetPosition_isSet = PFALSE;
		ch->position = PUNK_INT64;
		ch->maxPosition = 1000000000000000;
		ch->minPosition = -1000000000000000;
		ch->rescaleFactor = 1;
		ch->deadBand = 0;
		ch->deadBand_isSet = PFALSE;
		ch->kp = 10;
		ch->kp_isSet = PFALSE;
		ch->kd = 3000;
		ch->kd_isSet = PFALSE;
		break;
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		ch->dataInterval = 100;
		ch->dataInterval_isSet = PFALSE;
		ch->minDataInterval = 20;
		ch->maxDataInterval = 60000;
		ch->dutyCycle = PUNK_DBL;
		ch->engaged = 0;
		ch->engaged_isSet = PFALSE;
		ch->velocityLimit = 1000;
		ch->velocityLimit_isSet = PFALSE;
		ch->minVelocityLimit = 0;
		ch->maxVelocityLimit = 10000;
		ch->maxAcceleration = 100000;
		ch->minAcceleration = 0.1;
		ch->acceleration = 100;
		ch->acceleration_isSet = PFALSE;
		ch->targetPosition = 0;
		ch->targetPosition_isSet = PFALSE;
		ch->position = PUNK_INT64;
		ch->maxPosition = 1000000000000000;
		ch->minPosition = -1000000000000000;
		ch->rescaleFactor = 1;
		ch->deadBand = 0;
		ch->deadBand_isSet = PFALSE;
		ch->kp = 400;
		ch->kp_isSet = PFALSE;
		ch->kd = 30000;
		ch->kd_isSet = PFALSE;
		ch->stallVelocity = 1000;
		ch->stallVelocity_isSet = PFALSE;
		ch->minStallVelocity = 0;
		ch->maxStallVelocity = 2000;
		break;
	default:
		MOS_PANIC("Unsupported Channel");
	}

	ch->positionOffset = 0;

	return (ret);
}

static PhidgetReturnCode CCONV
_setDefaults(PhidgetChannelHandle phid) {
	PhidgetMotorPositionControllerHandle ch;
	PhidgetReturnCode ret;

	TESTPTRL(phid);

	ch = (PhidgetMotorPositionControllerHandle)phid;
	ret = EPHIDGET_OK;

	switch (phid->UCD->uid) {
	case PHIDCHUID_DCC1000_MOTORPOSITIONCONTROLLER_200:
		break;
	case PHIDCHUID_DCC1001_MOTORPOSITIONCONTROLLER_100:
		if (ch->dataInterval_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETDATAINTERVAL, NULL, NULL, "%u", ch->dataInterval);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [dataInterval] default: %d", phid, ret);
				break;
			}
		}
		if (ch->currentLimit_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETCURRENTLIMIT, NULL, NULL, "%g", ch->currentLimit);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [currentLimit] default: %d", phid, ret);
				break;
			}
		}
		if (ch->engaged_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETENGAGED, NULL, NULL, "%d", ch->engaged);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [engaged] default: %d", phid, ret);
				break;
			}
		}
		if (ch->velocityLimit_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETDUTYCYCLE, NULL, NULL, "%g", ch->velocityLimit);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [velocityLimit] default: %d", phid, ret);
				break;
			}
		}
		if (ch->acceleration_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETACCELERATION, NULL, NULL, "%g", ch->acceleration);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [acceleration] default: %d", phid, ret);
				break;
			}
		}
		if (ch->targetPosition_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETTARGETPOSITION, NULL, NULL, "%l",
			  ch->targetPosition);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [targetPosition] default: %d", phid, ret);
				break;
			}
		}
		if (ch->deadBand_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETDEADBAND, NULL, NULL, "%u", ch->deadBand);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [deadBand] default: %d", phid, ret);
				break;
			}
		}
		if (ch->kp_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETKP, NULL, NULL, "%g", ch->kp);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [kp] default: %d", phid, ret);
				break;
			}
		}
		if (ch->kd_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETKD, NULL, NULL, "%g", ch->kd);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [kd] default: %d", phid, ret);
				break;
			}
		}
		break;
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		if (ch->dataInterval_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETDATAINTERVAL, NULL, NULL, "%u", ch->dataInterval);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [dataInterval] default: %d", phid, ret);
				break;
			}
		}
		if (ch->engaged_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETENGAGED, NULL, NULL, "%d", ch->engaged);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [engaged] default: %d", phid, ret);
				break;
			}
		}
		if (ch->velocityLimit_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETDUTYCYCLE, NULL, NULL, "%g", ch->velocityLimit);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [velocityLimit] default: %d", phid, ret);
				break;
			}
		}
		if (ch->acceleration_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETACCELERATION, NULL, NULL, "%g", ch->acceleration);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [acceleration] default: %d", phid, ret);
				break;
			}
		}
		if (ch->targetPosition_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETTARGETPOSITION, NULL, NULL, "%l",
			  ch->targetPosition);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [targetPosition] default: %d", phid, ret);
				break;
			}
		}
		if (ch->deadBand_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETDEADBAND, NULL, NULL, "%u", ch->deadBand);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [deadBand] default: %d", phid, ret);
				break;
			}
		}
		if (ch->kp_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETKP, NULL, NULL, "%g", ch->kp);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [kp] default: %d", phid, ret);
				break;
			}
		}
		if (ch->kd_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETKD, NULL, NULL, "%g", ch->kd);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [kd] default: %d", phid, ret);
				break;
			}
		}
		if (ch->stallVelocity_isSet == PFALSE) {
			ret = bridgeSendToDevice(phid, BP_SETSTALLVELOCITY, NULL, NULL, "%g", ch->stallVelocity);
			if (ret != EPHIDGET_OK) {
				logerr("%P: failed to set [stallVelocity] default: %d", phid, ret);
				break;
			}
		}
		break;
	default:
		MOS_PANIC("Unsupported Channel");
	}

	return (ret);
}

static void CCONV
_fireInitialEvents(PhidgetChannelHandle phid) {
	PhidgetMotorPositionControllerHandle ch;

	ch = (PhidgetMotorPositionControllerHandle)phid;

	if(ch->dutyCycle != PUNK_DBL)
		FIRECH(ch, DutyCycleUpdate, ch->dutyCycle);

}

static void CCONV
PhidgetMotorPositionController_free(PhidgetChannelHandle *ch) {

	mos_free(*ch, sizeof (struct _PhidgetMotorPositionController));
}

API_PRETURN
PhidgetMotorPositionController_create(PhidgetMotorPositionControllerHandle *phidp) {

	CHANNELCREATE_BODY(MotorPositionController, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_delete(PhidgetMotorPositionControllerHandle *phidp) {

	return (Phidget_delete((PhidgetHandle *)phidp));
}

API_PRETURN
PhidgetMotorPositionController_setCurrentLimit(PhidgetMotorPositionControllerHandle ch,
  double currentLimit) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETCURRENTLIMIT, NULL, NULL, "%g",
	  currentLimit));
}

API_PRETURN
PhidgetMotorPositionController_getCurrentLimit(PhidgetMotorPositionControllerHandle ch,
  double *currentLimit) {

	TESTPTRL(ch);
	TESTPTRL(currentLimit);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*currentLimit = ch->currentLimit;
	if (ch->currentLimit == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getMinCurrentLimit(PhidgetMotorPositionControllerHandle ch,
  double *minCurrentLimit) {

	TESTPTRL(ch);
	TESTPTRL(minCurrentLimit);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*minCurrentLimit = ch->minCurrentLimit;
	if (ch->minCurrentLimit == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getMaxCurrentLimit(PhidgetMotorPositionControllerHandle ch,
  double *maxCurrentLimit) {

	TESTPTRL(ch);
	TESTPTRL(maxCurrentLimit);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*maxCurrentLimit = ch->maxCurrentLimit;
	if (ch->maxCurrentLimit == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setCurrentRegulatorGain(PhidgetMotorPositionControllerHandle ch,
  double currentRegulatorGain) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETCURRENTREGULATORGAIN, NULL, NULL, "%g",
	  currentRegulatorGain));
}

API_PRETURN
PhidgetMotorPositionController_getCurrentRegulatorGain(PhidgetMotorPositionControllerHandle ch,
  double *currentRegulatorGain) {

	TESTPTRL(ch);
	TESTPTRL(currentRegulatorGain);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1001_MOTORPOSITIONCONTROLLER_100:
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*currentRegulatorGain = ch->currentRegulatorGain;
	if (ch->currentRegulatorGain == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getMinCurrentRegulatorGain(PhidgetMotorPositionControllerHandle ch,
  double *minCurrentRegulatorGain) {

	TESTPTRL(ch);
	TESTPTRL(minCurrentRegulatorGain);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1001_MOTORPOSITIONCONTROLLER_100:
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*minCurrentRegulatorGain = ch->minCurrentRegulatorGain;
	if (ch->minCurrentRegulatorGain == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getMaxCurrentRegulatorGain(PhidgetMotorPositionControllerHandle ch,
  double *maxCurrentRegulatorGain) {

	TESTPTRL(ch);
	TESTPTRL(maxCurrentRegulatorGain);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1001_MOTORPOSITIONCONTROLLER_100:
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*maxCurrentRegulatorGain = ch->maxCurrentRegulatorGain;
	if (ch->maxCurrentRegulatorGain == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setDataInterval(PhidgetMotorPositionControllerHandle ch,
  uint32_t dataInterval) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETDATAINTERVAL, NULL, NULL, "%u",
	  dataInterval));
}

API_PRETURN
PhidgetMotorPositionController_getDataInterval(PhidgetMotorPositionControllerHandle ch,
  uint32_t *dataInterval) {

	TESTPTRL(ch);
	TESTPTRL(dataInterval);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*dataInterval = ch->dataInterval;
	if (ch->dataInterval == (uint32_t)PUNK_UINT32)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getMinDataInterval(PhidgetMotorPositionControllerHandle ch,
  uint32_t *minDataInterval) {

	TESTPTRL(ch);
	TESTPTRL(minDataInterval);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*minDataInterval = ch->minDataInterval;
	if (ch->minDataInterval == (uint32_t)PUNK_UINT32)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getMaxDataInterval(PhidgetMotorPositionControllerHandle ch,
  uint32_t *maxDataInterval) {

	TESTPTRL(ch);
	TESTPTRL(maxDataInterval);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*maxDataInterval = ch->maxDataInterval;
	if (ch->maxDataInterval == (uint32_t)PUNK_UINT32)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getDutyCycle(PhidgetMotorPositionControllerHandle ch,
  double *dutyCycle) {

	TESTPTRL(ch);
	TESTPTRL(dutyCycle);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*dutyCycle = ch->dutyCycle;
	if (ch->dutyCycle == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setEngaged(PhidgetMotorPositionControllerHandle ch, int engaged) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETENGAGED, NULL, NULL, "%d", engaged));
}

API_PRETURN
PhidgetMotorPositionController_getEngaged(PhidgetMotorPositionControllerHandle ch, int *engaged) {

	TESTPTRL(ch);
	TESTPTRL(engaged);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*engaged = ch->engaged;
	if (ch->engaged == (int)PUNK_BOOL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setFanMode(PhidgetMotorPositionControllerHandle ch,
  Phidget_FanMode fanMode) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETFANMODE, NULL, NULL, "%d", fanMode));
}

API_PRETURN
PhidgetMotorPositionController_getFanMode(PhidgetMotorPositionControllerHandle ch,
  Phidget_FanMode *fanMode) {

	TESTPTRL(ch);
	TESTPTRL(fanMode);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1001_MOTORPOSITIONCONTROLLER_100:
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*fanMode = ch->fanMode;
	if (ch->fanMode == (Phidget_FanMode)PUNK_ENUM)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setIOMode(PhidgetMotorPositionControllerHandle ch,
  Phidget_EncoderIOMode IOMode) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETIOMODE, NULL, NULL, "%d", IOMode));
}

API_PRETURN
PhidgetMotorPositionController_getIOMode(PhidgetMotorPositionControllerHandle ch,
  Phidget_EncoderIOMode *IOMode) {

	TESTPTRL(ch);
	TESTPTRL(IOMode);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	switch (ch->phid.UCD->uid) {
	case PHIDCHUID_DCC1001_MOTORPOSITIONCONTROLLER_100:
	case PHIDCHUID_DCC1100_MOTORPOSITIONCONTROLLER_100:
		return (EPHIDGET_UNSUPPORTED);
	default:
		break;
	}

	*IOMode = ch->IOMode;
	if (ch->IOMode == (Phidget_EncoderIOMode)PUNK_ENUM)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setKd(PhidgetMotorPositionControllerHandle ch, double kd) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETKD, NULL, NULL, "%g", kd));
}

API_PRETURN
PhidgetMotorPositionController_getKd(PhidgetMotorPositionControllerHandle ch, double *kd) {

	TESTPTRL(ch);
	TESTPTRL(kd);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*kd = ch->kd;
	if (ch->kd == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setKp(PhidgetMotorPositionControllerHandle ch, double kp) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	return (bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETKP, NULL, NULL, "%g", kp));
}

API_PRETURN
PhidgetMotorPositionController_getKp(PhidgetMotorPositionControllerHandle ch, double *kp) {

	TESTPTRL(ch);
	TESTPTRL(kp);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*kp = ch->kp;
	if (ch->kp == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_getRescaleFactor(PhidgetMotorPositionControllerHandle ch,
  double *rescaleFactor) {

	TESTPTRL(ch);
	TESTPTRL(rescaleFactor);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);
	TESTATTACHEDL(ch);

	*rescaleFactor = ch->rescaleFactor;
	if (ch->rescaleFactor == (double)PUNK_DBL)
		return (EPHIDGET_UNKNOWNVAL);
	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setOnDutyCycleUpdateHandler(PhidgetMotorPositionControllerHandle ch,
  PhidgetMotorPositionController_OnDutyCycleUpdateCallback fptr, void *ctx) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);

	ch->DutyCycleUpdate = fptr;
	ch->DutyCycleUpdateCtx = ctx;

	return (EPHIDGET_OK);
}

API_PRETURN
PhidgetMotorPositionController_setOnPositionChangeHandler(PhidgetMotorPositionControllerHandle ch,
  PhidgetMotorPositionController_OnPositionChangeCallback fptr, void *ctx) {

	TESTPTRL(ch);
	TESTCHANNELCLASSL(ch, PHIDCHCLASS_MOTORPOSITIONCONTROLLER);

	ch->PositionChange = fptr;
	ch->PositionChangeCtx = ctx;

	return (EPHIDGET_OK);
}
